// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "VNTextEventParser.hpp"

using namespace Dawn;

std::vector<std::string> VNTextEventParser::getRequiredAttributes() {
  return { };
}

std::map<std::string, std::string> VNTextEventParser::getOptionalAttributes() {
  return { };
}

int32_t VNTextEventParser::onParse(
  Xml *node,
  std::map<std::string, std::string> values,
  struct VNTextEvent *out,
  std::string *error
) {
  auto itChildren = node->children.begin();
  while(itChildren != node->children.end()) {
    Xml *child = *itChildren;

    // Parse strings
    if(child->node == "string") {
      VNText text;
      text.language = child->attributes["lang"];
      text.text = child->value;
      out->texts.push_back(text);
    } else {
      *error = "Unknown child node '" + child->node + "'";
      return -1;
    }

    itChildren++;
  }

  return 0;
}